lab_1/urls.py
from django.urls import path
from .views import index
from .views import friend_list


urlpatterns = [
    path('', index, name='index'),
    path('friends', friend_list)
    # TODO Add friends path using friend_list Views
]

lab_2/urls.py
from django.urls import path
from .views import index
from .views import xml
from .views import json



urlpatterns = [
    path('', index, name='index'),
    path('xml', xml),
    path('json', json)
   
    # TODO Add friends path using friend_list Views
]

lab_3/urls.py
from django.urls import path
from .views import add_friend, index



urlpatterns = [
    path('', index, name='index'),
    path('add', add_friend)

    # TODO Add friends path using friend_list Views
]

lab_4/urls.py
from django.urls import path
from .views import index, add_message,card_message


app_name = 'lab4'


urlpatterns = [
    path('', index, name='index'),
    path('add_message/', add_message, name="add_message"),
    path('card_message/', card_message, name="card_message")
    
   
    # TODO Add friends path using friend_list Views
]

praktikum/urls.py
from django.urls import path, re_path,include
from django.contrib import admin
import lab_1.urls as lab_1
import lab_2.urls as lab_2
import lab_3.urls as lab_3
import lab_4.urls as lab_4
from lab_1.views import index as index_lab1
from lab_1.views import friend_list


urlpatterns = [
    path('admin/', admin.site.urls),
    path('lab-1/', include(lab_1)),
    path('lab-2/', include(lab_2)),
    path('lab-3/', include(lab_3)),
    path('lab-4/', include(lab_4)),
    path('lab-1/friends', friend_list),
    re_path(r'^$', index_lab1, name='index')
]

lab_1/models.py
from django.db import models

# TODO Create Friend model that contains name, npm, and DOB (date of birth) here


class Friend(models.Model):
    name = models.CharField(max_length=30)
    npm = models.BigIntegerField()
    DOB = models.DateField()
    # TODO Implement missing attributes in Friend model

lab_2/models.py
from django.db import models

# Create your models here.

class Note(models.Model):
    judul = models.CharField(max_length=50)
    penerima = models.CharField(max_length=50)
    pengirim = models.CharField(max_length=50)
    message = models.TextField()

lab_3/models.py
from django.db import models

# Create your models here.
class Friend(models.Model):
    name = models.CharField(max_length=30)
    npm = models.BigIntegerField()
    DOB = models.DateField()

lab_4/models.py
from django.db import models

# Create your models here.

class Note(models.Model):
    title = models.CharField(max_length=50)
    penerima = models.CharField(max_length=50)
    pengirim = models.CharField(max_length=50)
    message = models.TextField()

lab_3/forms.py
from lab_1.models import Friend
from django.forms import ModelForm

class FriendForm(ModelForm):
    class Meta:
        model = Friend
        fields=['name', 'npm', 'DOB']

lab_4/forms.py
from .models import Note
from django.forms import ModelForm

class NoteForm(ModelForm):
    class Meta:
        model = Note
        fields='__all__'

lab_1/views.py
from django.shortcuts import render
from datetime import datetime, date
from .models import Friend

mhs_name = 'Reyza Abyan Gerrit Caloh'  # TODO Implement this
curr_year = int(datetime.now().strftime("%Y"))
birth_date = date(2003,1, 24)  # TODO Implement this, format (Year, Month, Date)
npm = 2006463534  # TODO Implement this


def index(request):
    response = {'name': mhs_name,
                'age': calculate_age(birth_date.year),
                'npm': npm}
    return render(request, 'index_lab1.html', response)


def calculate_age(birth_year):
    return curr_year - birth_year if birth_year <= curr_year else 0


def friend_list(request):
    friends = Friend.objects.all() # TODO Implement this
    response = {'friends': friends}
    return render(request, 'friend_list_lab1.html', response)

lab_2/views.py
from lab_2.models import Note
from django.shortcuts import render
from django.http.response import HttpResponse
from django.core import serializers

# Create your views here.
judul = 'Short Message'  # TODO Implement this
penerima = "You"
pengirim = "Me"  # TODO Implement this, format (Year, Month, Date)
message = "Wish u all the best"  # TODO Implement this


def index(request):
    response = {'judul':judul,
                'penerima': penerima,
                'message' :message,
                'pengirim': pengirim
                }
    return render(request, 'lab2.html', response)

def xml(request):
    data = serializers.serialize('xml', Note.objects.all())
    return HttpResponse(data, content_type="application/xml")

def json(request):
    
    data = serializers.serialize('json', Note.objects.all())
    return HttpResponse(data, content_type="application/json")

lab_3/views.py
from django.shortcuts import render
from datetime import datetime, date
from lab_1.models import Friend
from lab_1.views import calculate_age
from lab_3.forms import FriendForm
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect


mhs_name = 'Reyza Abyan Gerrit Caloh'  # TODO Implement this
curr_year = int(datetime.now().strftime("%Y"))
birth_date = date(2003,1, 24)  # TODO Implement this, format (Year, Month, Date)
npm = 2006463534  # TODO Implement this

@login_required(login_url="/admin/login/")
def index(request):
    friends = Friend.objects.all() # TODO Implement this
    response = {'friends': friends}
    return render(request, 'lab3_index.html', response)


def add_friend(request):
    if request.method == 'POST':
        form = FriendForm(request.POST)
        if form.is_valid():
            form.save()  
            return HttpResponseRedirect('/lab-3/')  # Redirect on finish
    else:
        form = FriendForm()

    return render(request, 'lab3_form.html', {'form': form})

lab_4/views.py
from django.shortcuts import render, redirect
from lab_4.forms import NoteForm
from django.http import HttpResponseRedirect
from .models import Note

# Create your views here.

judul = 'Short Message'  # TODO Implement this
penerima = "You"
pengirim = "Me"  # TODO Implement this, format (Year, Month, Date)
message = "Wish u all the best"  # TODO Implement this


def index(request):
    notes = Note.objects.all()
    data = {"list_note" : notes} 
    return render(request, 'lab4_bsindex.html', context=data)

def add_message(request):
    if request.method == 'POST':
        form = NoteForm(request.POST)
        if form.is_valid():
            form.save()  
            Note.objects.create(
                form
            )
            return redirect('lab-4:index')  # Redirect on finish
    else:
        form = NoteForm()

    return render(request, 'lab4_bsindex.html', {'form': form})


def card_message(request):
    notes = Note.objects.all()
    data = {"list_note" : notes} 
    return render(request, 'lab4_cdindex.html', context=data)

lab_1/templates/friend_list_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      {% if friends %}
        {% for friend in friends%}
        <tr>
          <td>{{ friend.name }}</td>
          <td>{{ friend.npm }}</td>
          <td>{{ friend.DOB }}</td>
		    </tr>
		    {% endfor %}
	    {% endif %}

    </table>
  </body>
</html>

lab_1/templates/index_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>{{ name }}</title>
  </head>
  <body>
    <h1>Hello my name is {{ name }}</h1>
    <article>NPM : {{ npm }}</article>
    <article>I am {{ age }} years old</article>
  </body>
</html>

lab_2/templates/lab2.html
<!DOCTYPE html>
<html>
  <head>
    <title>{{judul}}</title>
  </head>
  <body>
    <br>
    <p>To: {{penerima}}</p>
    <p>{{message}}</p>
    <br>
    <p>Sincerely,</p>
    <p>{{pengirim}}</p>
  </body>
</html>

lab_3/templates/lab3_form.html
<!DOCTYPE html>
<html lang="en">
    <body>
        <form action="" method="POST">
            {% csrf_token %}
            <table>
                {{ form.as_p }}
                <tr>
                    <td colspan="2">
                        <input type="submit" value="Submit">
                    </td>
                </tr>
            </table>
        </form>
    </body>
</html>

lab_3/templates/lab3_index.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      {% if friends %}
        {% for friend in friends%}
        <tr>
          <td>{{ friend.name }}</td>
          <td>{{ friend.npm }}</td>
          <td>{{ friend.DOB }}</td>
		    </tr>
		    {% endfor %}
	    {% endif %}

    </table>
  </body>
</html>

lab_4/templates/lab4_bsindex.html
{% extends 'navbar.html' %}
{% block content %}

    <br>
    <h1>List of Message</h1>
    <br>

    <table class="table table-bordered">
        <thead>
          <tr>
            <th scope="col">From</th>
            <th scope="col">To</th>
            <th scope="col">Title</th>
            <th scope="col">Message</th>
          </tr>
        </thead>
        <tbody>
            {% for note in list_note %}
            <tr>
              <td>{{ note.penerima }}</td>
              <td>{{ note.pengirim }}</td>
              <td>{{ note.title }}</td>
              <td>{{ note.message }}</td>
            </tr>
            {% endfor %}
          </tbody>
      </table>

      <!-- Button trigger modal -->
    <button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#exampleModal" >
      Add new message
    </button>

    <!-- Modal -->
    <div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Create new Note</h5>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
          </div>

          <div class="modal-body">
            <form action="{% url 'lab4:add_message' %}" method="post">
              {% csrf_token %}
              <div class="mb-3">
                <label for="title" class="form-label">Title</label>
                <input type="text" class="form-control" id="title" name="title">
              </div>
              <div class="mb-3">
                <label for="pengirim" class="form-label">From</label>
                <input type="text" class="form-control" id="pengirim" name="pengirim">
              </div>
              <div class="mb-3">
                <label for="penerima" class="form-label">To</label>
                <input type="text" class="form-control" id="penerima" name="penerima">
              </div>
              <div class="mb-3">
                <label for="message" class="form-label">Message</label>
                <input type="text" class="form-control" id="message" name="message">
              </div>
              <button type="submit" class="btn btn-primary">Submit</button>
            </form>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
          </div>
        </div>
      </div>
    </div>
  </div>

{% endblock content %}

lab_4/templates/lab4_cdindex.html
{% extends 'navbar.html' %}
{% block content %}

 
      <div class="row row-cols-1 row-cols-md-3 g-4">
        {% for note in list_note %}
        <div class="col">
          
          <div class="card h-100">
            <div class="card text-white bg-dark mb-3"  >
              <h5 class="card-title">{{ note.title }}</h5>
              <p class="card-text">From: {{ note.pengirim }}</p>
              <p class="card-text">To: {{ note.penerima }}</p>
              <p class="card-text">Message: </p>
              <p class="card-text">   {{ note.message }}</p>
            </div>
          </div>
          
        </div>
        {% endfor %}
      </div>
      {% endblock content %}

lab_4/templates/navbar.html
<!doctype html>
<html lang="en">


<head>
  <!-- Required meta tags -->
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- Bootstrap CSS -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" rel="stylesheet"
    integrity="sha384-F3w7mX95PdgyTmZZMECAngseQB83DfGTowi0iMjiWaeVhAn4FJkqJByhZMI3AhiU" crossorigin="anonymous">

  <title>Message</title>
</head>

<body>
  <nav class="navbar navbar-expand-lg navbar-light bg-light">
    <div class="container-fluid">
      <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent"
        aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarSupportedContent">
        <ul class="navbar-nav me-auto mb-2 mb-lg-0">
          <li class="nav-item">
            <a class="nav-link active" aria-current="page" href="{% url 'lab4:index' %}">Table</a>
          </li>
          <li class="nav-item">
            <a class="nav-link active" aria-current="page" href="{% url 'lab4:card_message' %}">Card</a>
          </li>
         
        </ul>
      </div>
    </div>
  </nav>
  {% block content %}

  {% endblock content %}

  <!-- Optional JavaScript; choose one of the two! -->

  <!-- Option 1: Bootstrap Bundle with Popper -->
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js"
    integrity="sha384-/bQdsTh/da6pkI1MST/rWKFNjaCP5gBSY4sEBT38Q/9RBh9AH40zEOg7Hlq2THRZ"
    crossorigin="anonymous"></script>

  <!-- Option 2: Separate Popper and Bootstrap JS -->
  <!--
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.9.3/dist/umd/popper.min.js" integrity="sha384-W8fXfP3gkOKtndU4JGtKDvXbO53Wy8SZCQHczT5FMiiqmQfUpWbYdTil/SxwZgAN" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.min.js" integrity="sha384-skAcpIdS7UcVUC05LJ9Dxay8AXcDYfBJqt1CJ85S/CFujBsIzCIv+l9liuYLaMQ/" crossorigin="anonymous"></script>
    -->
</body>

</html>